//-----------------------------------------
//
// Generated by nedtool, version 3.3
// date: Sun Dec 30 21:12:23 2007
//
//-----------------------------------------


#include <math.h>
#include "omnetpp.h"

// NEDC version check
#define NEDC_VERSION 0x0303
#if (NEDC_VERSION!=OMNETPP_VERSION)
#    error Version mismatch! Probably this file was generated by an earlier version of nedc: 'make clean' should help.
#endif

// Disable warnings about unused variables. For MSVC and BC only:
// GCC has no way to turn on its -Wunused option in a source file :(
#ifdef _MSC_VER
#  pragma warning(disable:4101)
#endif
#ifdef __BORLANDC__
#  pragma warn -waus
#  pragma warn -wuse
#endif

static cModuleType *_getModuleType(const char *modname)
{
    cModuleType *modtype = findModuleType(modname);
    if (!modtype)
        throw new cRuntimeError("Module type definition %s not found (Define_Module() missing from C++ code?)", modname);
    return modtype;
}

static void _checkModuleVectorSize(int vectorsize, const char *mod)
{
    if (vectorsize<0)
        throw new cRuntimeError("Negative module vector size %s[%d]", mod, vectorsize);
}

static void _readModuleParameters(cModule *mod)
{
    int n = mod->params();
    for (int k=0; k<n; k++)
        if (mod->par(k).isInput())
            mod->par(k).read();
}

static int _checkModuleIndex(int index, int vectorsize, const char *modname)
{
    if (index<0 || index>=vectorsize)
        throw new cRuntimeError("Submodule index %s[%d] out of range, sizeof(%s) is %d", modname, index, modname, vectorsize);
    return index;
}

static cGate *_checkGate(cModule *mod, const char *gatename)
{
    cGate *g = mod->gate(gatename);
    if (!g)
        throw new cRuntimeError("%s has no gate named %s",mod->fullPath().c_str(), gatename);
    return g;
}

static cGate *_checkGate(cModule *mod, const char *gatename, int gateindex)
{
    cGate *g = mod->gate(gatename, gateindex);
    if (!g)
        throw new cRuntimeError("%s has no gate %s[%d]",mod->fullPath().c_str(), gatename, gateindex);
    return g;
}

static cGate *_getFirstUnusedParentModGate(cModule *mod, const char *gatename)
{
    int baseId = mod->findGate(gatename);
    if (baseId<0)
        throw new cRuntimeError("%s has no %s[] gate",mod->fullPath().c_str(), gatename);
    int n = mod->gate(baseId)->size();
    for (int i=0; i<n; i++)
        if (!mod->gate(baseId+i)->isConnectedInside())
            return mod->gate(baseId+i);
    throw new cRuntimeError("%s[] gates are all connected, no gate left for `++' operator",mod->fullPath().c_str(), gatename);
}

static cGate *_getFirstUnusedSubmodGate(cModule *mod, const char *gatename)
{
    int baseId = mod->findGate(gatename);
    if (baseId<0)
        throw new cRuntimeError("%s has no %s[] gate",mod->fullPath().c_str(), gatename);
    int n = mod->gate(baseId)->size();
    for (int i=0; i<n; i++)
        if (!mod->gate(baseId+i)->isConnectedOutside())
            return mod->gate(baseId+i);
    int newBaseId = mod->setGateSize(gatename,n+1);
    return mod->gate(newBaseId+n);
}

static cFunctionType *_getFunction(const char *funcname, int argcount)
{
    cFunctionType *functype = findFunction(funcname,argcount);
    if (!functype)
        throw new cRuntimeError("Function %s with %d args not found", funcname, argcount);
    return functype;
}

static cChannel *_createChannel(const char *channeltypename)
{
    cChannelType *channeltype = findChannelType(channeltypename);
    if (!channeltype)
        throw new cRuntimeError("Channel type %s not found", channeltypename);
    cChannel *channel = channeltype->create("channel");
    return channel;
}

static cChannel *_createNonTypedBasicChannel(double delay, double error, double datarate)
{
    cBasicChannel *channel = new cBasicChannel("channel");
    if (delay!=0) channel->setDelay(delay);
    if (error!=0) channel->setError(error);
    if (datarate!=0) channel->setDatarate(datarate);
    return channel;
}

static cXMLElement *_getXMLDocument(const char *fname, const char *pathexpr=NULL)
{
    cXMLElement *node = ev.getXMLDocument(fname, pathexpr);
    if (!node)
        throw new cRuntimeError(!pathexpr ? "xmldoc(\"%s\"): element not found" : "xmldoc(\"%s\", \"%s\"): element not found",fname,pathexpr);
    return node;
}

ModuleInterface(Network)
EndInterface

Register_ModuleInterface(Network);

class Network : public cCompoundModule
{
  public:
    Network() : cCompoundModule() {}
  protected:
    virtual void doBuildInside();
};

Define_Module(Network);

void Network::doBuildInside()
{
    cModule *mod = this;

    // temporary variables:
    cPar tmpval;
    const char *modtypename;

    // submodules:
    cModuleType *modtype = NULL;
    int submodindex;

    //
    // submodule 'gen':
    //
    int gen_size = 1;
    modtype = _getModuleType("Generator");
    cModule *gen_p = modtype->create("gen", mod);
    {
        cContextSwitcher __ctx(gen_p); // do the rest in this module's context

        // parameter assignments:
        gen_p->par("num_messages") = (tmpval=0L, tmpval.setInput(true), tmpval);
        gen_p->par("ia_time") = (tmpval=0L, tmpval.setInput(true), tmpval);

        _readModuleParameters(gen_p);
        gen_p->setDisplayString("i=block/source");
    }

    //
    // submodule 'fifo':
    //
    int fifo_size = 1;
    modtype = _getModuleType("Fifo");
    cModule *fifo_p = modtype->create("fifo", mod);
    {
        cContextSwitcher __ctx(fifo_p); // do the rest in this module's context

        // parameter assignments:
        fifo_p->par("size") = (tmpval=0L, tmpval.setInput(true), tmpval);

        _readModuleParameters(fifo_p);
        fifo_p->setDisplayString("i=block/passiveq;q=queue");
    }

    //
    // submodule 'server':
    //
    int server_size = 1;
    modtype = _getModuleType("Server");
    cModule *server_p = modtype->create("server", mod);
    {
        cContextSwitcher __ctx(server_p); // do the rest in this module's context

        // parameter assignments:
        server_p->par("service_time") = (tmpval=0L, tmpval.setInput(true), tmpval);

        _readModuleParameters(server_p);
        server_p->setDisplayString("i=block/server");
    }

    //
    // submodule 'sink':
    //
    int sink_size = 1;
    modtype = _getModuleType("Sink");
    cModule *sink_p = modtype->create("sink", mod);
    {
        cContextSwitcher __ctx(sink_p); // do the rest in this module's context

        _readModuleParameters(sink_p);
        sink_p->setDisplayString("p=;i=sink");
    }

    //
    // connections:
    //
    cGate *srcgate, *destgate;

    cChannel *channel;
    cPar *par;
    // connection
    srcgate = _checkGate(gen_p, "out");
    destgate = _checkGate(fifo_p, "inUpstream");
    srcgate->connectTo(destgate);

    // connection
    srcgate = _checkGate(fifo_p, "outUpstream");
    destgate = _checkGate(gen_p, "inDownstream");
    srcgate->connectTo(destgate);

    // connection
    srcgate = _checkGate(fifo_p, "outDownstream");
    destgate = _checkGate(server_p, "inUpstream");
    srcgate->connectTo(destgate);

    // connection
    srcgate = _checkGate(server_p, "outUpstream");
    destgate = _checkGate(fifo_p, "inDownstream");
    srcgate->connectTo(destgate);

    // connection
    srcgate = _checkGate(server_p, "outDownstream");
    destgate = _checkGate(sink_p, "inUpstream");
    srcgate->connectTo(destgate);

    // connection
    srcgate = _checkGate(sink_p, "outUpstream");
    destgate = _checkGate(server_p, "inDownstream");
    srcgate->connectTo(destgate);

    // check all gates are connected:
    mod->checkInternalConnections();


    //
    // this level is done -- recursively build submodules too
    //
    gen_p->buildInside();
    fifo_p->buildInside();
    server_p->buildInside();
    sink_p->buildInside();
}

class blocked : public cNetworkType
{
  public:
    blocked(const char *name) : cNetworkType(name) {}
    blocked(const blocked& n) : cNetworkType(n.name()) {operator=(n);}
    virtual void setupNetwork();
};

Define_Network(blocked);

void blocked::setupNetwork()
{
    // temporary variables:
    cPar tmpval;
    const char *modtypename;

    cModuleType *modtype;

    modtype = _getModuleType("Network");
    cModule *blocked_p = modtype->create("blocked", NULL);

    cContextSwitcher __ctx(blocked_p); // do the rest in this module's context
    _readModuleParameters(blocked_p);
    // build submodules recursively (if it has any):
    blocked_p->buildInside();
}

